/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package com.cosmodas.EntCosmos;

import java.io.Serializable;
import java.util.Date;
import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;
import javax.validation.constraints.NotNull;
import javax.validation.constraints.Size;
import javax.xml.bind.annotation.XmlRootElement;

/**
 * @author obper
 */
@Entity
@Table(name = "hproductos_zonas_total")
@XmlRootElement
@NamedQueries({
        @NamedQuery(name = "HproductosZonasTotal.findAll", query = "SELECT h FROM HproductosZonasTotal h")
        , @NamedQuery(name = "HproductosZonasTotal.findByZona", query = "SELECT h FROM HproductosZonasTotal h WHERE h.zona = :zona")
        , @NamedQuery(name = "HproductosZonasTotal.findByCantidad", query = "SELECT h FROM HproductosZonasTotal h WHERE h.cantidad = :cantidad")
        , @NamedQuery(name = "HproductosZonasTotal.findByCajas", query = "SELECT h FROM HproductosZonasTotal h WHERE h.cajas = :cajas")
        , @NamedQuery(name = "HproductosZonasTotal.findByFecha", query = "SELECT h FROM HproductosZonasTotal h WHERE h.fecha = :fecha")
        , @NamedQuery(name = "HproductosZonasTotal.findByObservacion", query = "SELECT h FROM HproductosZonasTotal h WHERE h.observacion = :observacion")
        , @NamedQuery(name = "HproductosZonasTotal.findByIdzone", query = "SELECT h FROM HproductosZonasTotal h WHERE h.idzone = :idzone")
        , @NamedQuery(name = "HproductosZonasTotal.findByFingreso", query = "SELECT h FROM HproductosZonasTotal h WHERE h.fingreso = :fingreso")
        , @NamedQuery(name = "HproductosZonasTotal.findBySucursalCodigo", query = "SELECT h FROM HproductosZonasTotal h WHERE h.sucursalCodigo = :sucursalCodigo")
        , @NamedQuery(name = "HproductosZonasTotal.findBySinTablet", query = "SELECT h FROM HproductosZonasTotal h WHERE h.sinTablet = :sinTablet")
        , @NamedQuery(name = "HproductosZonasTotal.findByIdzonetablet", query = "SELECT h FROM HproductosZonasTotal h WHERE h.idzonetablet = :idzonetablet")
        , @NamedQuery(name = "HproductosZonasTotal.findByProgramaCodigo", query = "SELECT h FROM HproductosZonasTotal h WHERE h.programaCodigo = :programaCodigo")})
public class HproductosZonasTotal implements Serializable {

    private static final long serialVersionUID = 1L;
    @Basic(optional = false)
    @NotNull
    @Size(min = 1, max = 2)
    @Column(name = "zona")
    private String zona;
    @Basic(optional = false)
    @NotNull
    @Column(name = "cantidad")
    private short cantidad;
    @Basic(optional = false)
    @NotNull
    @Column(name = "cajas")
    private short cajas;
    @Basic(optional = false)
    @NotNull
    @Size(min = 1, max = 14)
    @Column(name = "fecha")
    private String fecha;
    @Basic(optional = false)
    @NotNull
    @Size(min = 1, max = 45)
    @Column(name = "observacion")
    private String observacion;
    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    @Basic(optional = false)
    @Column(name = "idzone")
    private Integer idzone;
    @Basic(optional = false)
    @NotNull
    @Column(name = "fingreso")
    @Temporal(TemporalType.DATE)
    private Date fingreso;
    @Basic(optional = false)
    @NotNull
    @Column(name = "sucursal_codigo")
    private int sucursalCodigo;
    @Basic(optional = false)
    @NotNull
    @Column(name = "sin_tablet")
    private boolean sinTablet;
    @Basic(optional = false)
    @NotNull
    @Column(name = "idzonetablet")
    private int idzonetablet;
    @Size(max = 3)
    @Column(name = "programa_codigo")
    private String programaCodigo;
    @Size(max = 3)
    @Column(name = "usuario_codigo")
    private String usuarioCodigo;
    @JoinColumn(name = "producto_codigo", referencedColumnName = "producto_codigo")
    @ManyToOne(optional = false)
    private Productos productoCodigo;

    public HproductosZonasTotal() {
    }

    public HproductosZonasTotal(Integer idzone) {
        this.idzone = idzone;
    }

    public HproductosZonasTotal(Integer idzone, String zona, short cantidad, short cajas, String fecha, String observacion, Date fingreso, int sucursalCodigo, boolean sinTablet, int idzonetablet) {
        this.idzone = idzone;
        this.zona = zona;
        this.cantidad = cantidad;
        this.cajas = cajas;
        this.fecha = fecha;
        this.observacion = observacion;
        this.fingreso = fingreso;
        this.sucursalCodigo = sucursalCodigo;
        this.sinTablet = sinTablet;
        this.idzonetablet = idzonetablet;
    }

    public String getZona() {
        return zona;
    }

    public void setZona(String zona) {
        this.zona = zona;
    }

    public short getCantidad() {
        return cantidad;
    }

    public void setCantidad(short cantidad) {
        this.cantidad = cantidad;
    }

    public short getCajas() {
        return cajas;
    }

    public void setCajas(short cajas) {
        this.cajas = cajas;
    }

    public String getFecha() {
        return fecha;
    }

    public void setFecha(String fecha) {
        this.fecha = fecha;
    }

    public String getObservacion() {
        return observacion;
    }

    public void setObservacion(String observacion) {
        this.observacion = observacion;
    }

    public Integer getIdzone() {
        return idzone;
    }

    public void setIdzone(Integer idzone) {
        this.idzone = idzone;
    }

    public Date getFingreso() {
        return fingreso;
    }

    public void setFingreso(Date fingreso) {
        this.fingreso = fingreso;
    }

    public int getSucursalCodigo() {
        return sucursalCodigo;
    }

    public void setSucursalCodigo(int sucursalCodigo) {
        this.sucursalCodigo = sucursalCodigo;
    }

    public boolean getSinTablet() {
        return sinTablet;
    }

    public void setSinTablet(boolean sinTablet) {
        this.sinTablet = sinTablet;
    }

    public int getIdzonetablet() {
        return idzonetablet;
    }

    public void setIdzonetablet(int idzonetablet) {
        this.idzonetablet = idzonetablet;
    }

    public String getProgramaCodigo() {
        return programaCodigo;
    }

    public void setProgramaCodigo(String programaCodigo) {
        this.programaCodigo = programaCodigo;
    }

    public String getUsuarioCodigo() {
        return usuarioCodigo;
    }

    public void setUsuarioCodigo(String usuarioCodigo) {
        this.usuarioCodigo = usuarioCodigo;
    }

    public Productos getProductoCodigo() {
        return productoCodigo;
    }

    public void setProductoCodigo(Productos productoCodigo) {
        this.productoCodigo = productoCodigo;
    }

    @Override
    public int hashCode() {
        int hash = 0;
        hash += (idzone != null ? idzone.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof HproductosZonasTotal)) {
            return false;
        }
        HproductosZonasTotal other = (HproductosZonasTotal) object;
        if ((this.idzone == null && other.idzone != null) || (this.idzone != null && !this.idzone.equals(other.idzone))) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return "com.cosmodas.dbcon.HproductosZonasTotal[ idzone=" + idzone + " ]";
    }

}
